#include "StdAfx.h"
#include "Application.h"
#include "NByteArray.h"
#include <atlapp.h>

IMPLEMENT_SINGLETON_CODE(Application);
Application::Application(void)
{
	m_Model = NULL;
	m_View = NULL;
	m_Control = NULL;
	m_MVCFactory = NULL;
	m_ZipMemory = NULL;
}
void Application::Init(IMVCFactory* facotory)
{		
	if (NULL == facotory) return;

	m_MVCFactory = facotory;
	
	Gdiplus::GdiplusStartup(&gdiplusToken, &gdiPlusStartupInput, &gdiPlusStartupOutput);
	m_View = m_MVCFactory->CreateView();
	m_Model = m_MVCFactory->CreateModel();
	m_Control = m_MVCFactory->CreateControl();

	if (m_View == NULL || m_Model == NULL || m_Control == NULL)
	{
		return;
	}	
	m_Control->SetModel(m_Model);
	m_Control->SetView(m_View);
	m_View->SetModel(m_Model);
	m_View->SetControl(m_Control);

	InitReousrce(m_MVCFactory);
}
void Application::Close()
{		
	if (m_MVCFactory != NULL)
	{
		if( m_Model)
		{
			m_MVCFactory->DestroyModel(m_Model);
			m_Model = NULL;
		}
		if( m_View)
		{
			m_MVCFactory->DestroyView(m_View);
			m_View= NULL;
		}
		if( m_Control)
		{
			m_MVCFactory->DestroyControl(m_Control);
			m_Control = NULL;
		}

		CloseReousrce();
	}
	Gdiplus::GdiplusShutdown(gdiplusToken);
}
void Application::PreRun()
{
	
	if (m_Model != NULL)
		m_Model->Init();
	if (m_View != NULL)
		m_View->Init();
	if (m_Control != NULL)
		m_Control->Init();
}
void Application::Run()
{
	if (m_View != NULL)
	{
// [:2008-12-01]     ֱ 
//		if (m_View->GetMainWindow() != NULL)
//		{
			CMessageLoop theLoop;
			int nRet = theLoop.Run();
//		}
	}	
}
void Application::PostRun()
{
	if( m_Control)
		m_Control->Close();
	if( m_View)
		m_View->Close();
	if( m_Model)
		m_Model->Close();
	
}
LPCTSTR Application::LoadString(LPCTSTR pszMsgID)
{
	return  Application::get_instance()->GetStringLoader()->GetString(pszMsgID);
}
IImage* Application::LoadImage(LPCTSTR pszcImageID)
{
	return Application::get_instance()->GetBinaryLoader()->GetImage(pszcImageID);
}
BOOL Application::FreeImage(IImage* pImage)
{
	Application::get_instance()->GetBinaryLoader()->FreeImage(pImage);
	return TRUE;
}
TiXmlElement* Application::LoadLayoutNode(LPCTSTR pszContainerID)
{
	return  Application::get_instance()->GetLayoutLoader()->GetPanelNode(pszContainerID);
}
BOOL Application::InitReousrce(IMVCFactory* facotory)
{
	ATLASSERT(facotory != NULL);
	TCHAR pathResource[_MAX_PATH] = {0};
	BOOL bSuccess = facotory->GetResourcePath(pathResource, _MAX_PATH);
	if (bSuccess)
	{
		CNByteArray ByteArrayPack;
		CNByteArray::ReadBufferFromURL(ByteArrayPack, pathResource);

		m_ZipMemory = new CNPMemoryData(ByteArrayPack.GetBuffer(), ByteArrayPack.GetSize());
		m_ZipImage.Open(m_ZipMemory);

		m_DefaultBinaryLoader.Init(&m_ZipImage);
		m_DefaultLayoutLoader.Init(&m_ZipImage);
		m_DefaultStringLoader.Init(&m_ZipImage);
	}
	return bSuccess;
}
BOOL Application::CloseReousrce()
{
	m_DefaultBinaryLoader.Close();
	m_DefaultLayoutLoader.Close();
	m_DefaultStringLoader.Close();
	m_ZipImage.Close();
	if (m_ZipMemory != NULL)
	{
		delete m_ZipMemory;
		m_ZipMemory = NULL;
	}
	return TRUE;
}